# class SIGTRAN | Abstract SIGTRAN user adaptation component. More...
Contains pure virtuals
Full name | `TelEngine::SIGTRAN`
Definition | `#include <libs/ysig/yatesig.h>`
Inherited by | ISDNIUAClient, SIGAdaptClient, SIGAdaptServer, SIGAdaptation, SS7M2PA, SS7M2UAClient
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum MsgClass { MGMT = 0, TRAN = 1, SSNM = 2, ASPSM = 3, ASPTM = 4, QPTM = 5, MAUP = 6, CLMSG = 7, COMSG = 8, RKM = 9, IIM = 10, M2PA = 11, }
- enum MsgMGMT { MgmtERR = 0, MgmtNTFY = 1, }
- enum MsgSSNM { SsnmDUNA = 1, SsnmDAVA = 2, SsnmDAUD = 3, SsnmSCON = 4, SsnmDUPU = 5, SsnmDRST = 6, }
- enum MsgASPSM { AspsmUP = 1, AspsmDOWN = 2, AspsmBEAT = 3, AspsmUP_ACK = 4, AspsmDOWN_ACK = 5, AspsmBEAT_ACK = 6, }
- enum MsgASPTM { AsptmACTIVE = 1, AsptmINACTIVE = 2, AsptmACTIVE_ACK = 3, AsptmINACTIVE_ACK = 4, }
- enum MsgRKM { RkmREG_REQ = 1, RkmREG_RSP = 2, RkmDEREG_REQ = 3, RkmDEREG_RSP = 4, }
- enum MsgIIM { IimREG_REQ = 1, IimREG_RSP = 2, IimDEREG_REQ = 3, IimDEREG_RSP = 4, }

#### Public Methods

- explicit SIGTRAN (u_int32_t payload = 0, u_int16_t port = 0)
- virtual ~SIGTRAN ()
- virtual void attach (SIGTransport* trans)
- inline SIGTransport* transport () const
- inline u_int32_t payload () const
- inline u_int16_t defPort () const
- bool connected (int streamId = 0) const
- virtual void notifyLayer (SignallingInterface::Notification status)
- bool transmitMSG (unsigned char msgVersion, unsigned char msgClass, unsigned char msgType, const DataBlock& msg, int streamId = 0) const
- inline bool transmitMSG (unsigned char msgClass, unsigned char msgType, const DataBlock& msg, int streamId = 0) const
- bool restart (bool force)
- bool getSocketParams (const String& params, NamedList& result)
- virtual bool transportNotify (SIGTransport* newTransport, const SocketAddr& addr)
- bool hasTransportThread ()
- void stopTransportThread ()

#### Public Static Methods

- static const TokenDict* classNames ()
- static const char* typeName (unsigned char msgClass, unsigned char msgType, const char* defValue = 0)

#### Protected Methods

- virtual bool processMSG (unsigned char msgVersion, unsigned char msgClass, unsigned char msgType, const DataBlock& msg, int streamId)

## Detailed Description

An interface to a Signalling Transport user adaptation component

enum MsgClass { MGMT = 0, TRAN = 1, SSNM = 2, ASPSM = 3, ASPTM = 4, QPTM = 5, MAUP = 6, CLMSG = 7, COMSG = 8, RKM = 9, IIM = 10, M2PA = 11, } | ### MsgClass

Message classes

enum MsgMGMT { MgmtERR = 0, MgmtNTFY = 1, } | ### MsgMGMT

Management messages

enum MsgSSNM { SsnmDUNA = 1, SsnmDAVA = 2, SsnmDAUD = 3, SsnmSCON = 4, SsnmDUPU = 5, SsnmDRST = 6, } | ### MsgSSNM

Signalling Network Management messages

enum MsgASPSM { AspsmUP = 1, AspsmDOWN = 2, AspsmBEAT = 3, AspsmUP_ACK = 4, AspsmDOWN_ACK = 5, AspsmBEAT_ACK = 6, } | ### MsgASPSM

ASP State Maintenance messages

enum MsgASPTM { AsptmACTIVE = 1, AsptmINACTIVE = 2, AsptmACTIVE_ACK = 3, AsptmINACTIVE_ACK = 4, } | ### MsgASPTM

ASP Traffic Maintenance messages

enum MsgRKM { RkmREG_REQ = 1, RkmREG_RSP = 2, RkmDEREG_REQ = 3, RkmDEREG_RSP = 4, } | ### MsgRKM

Routing Key Management messages

enum MsgIIM { IimREG_REQ = 1, IimREG_RSP = 2, IimDEREG_REQ = 3, IimDEREG_RSP = 4, } | ### MsgIIM

Interface Identifier Management messages

explicit SIGTRAN (u_int32_t payload = 0, u_int16_t port = 0) | ### SIGTRAN

Constructs an uninitialized signalling transport

Parameters:

payload | SCTP payload code, ignored for other transports
port | SCTP/TCP/UDP default port used for transport

~SIGTRAN () | ### ~SIGTRAN

[virtual]

Destructor, terminates transport layer

void attach (SIGTransport* trans) | ### attach

[virtual]

Attach a transport (connectivity provider)

Parameters:

trans | Transport to attach to this component

inline SIGTransport* transport () | ### transport

[const]

Get the transport of this user adaptation component

Returns: Pointer to the transport layer or NULL

inline u_int32_t payload () | ### payload

[const]

Get the SCTP payload of this user adaptation component

Returns: SCTP payload code

inline u_int16_t defPort () | ### defPort

[const]

Get the default SCTP/TCP/UDP port used for transport

Returns: Default protocol port, 0 if unknown or not set

bool connected (int streamId = 0) | ### connected

[const]

Check if the network transport layer is connected

Parameters:

streamId | Identifier of the stream to check if applicable

Returns: True if the transport (and stream if applicable) is connected

void notifyLayer (SignallingInterface::Notification status) | ### notifyLayer

[virtual]

const TokenDict* classNames () | ### classNames

[static]

Message class names dictionary

Returns: Pointer to dictionary of message classes

const char* typeName (unsigned char msgClass, unsigned char msgType, const char* defValue = 0) | ### typeName

[static]

Message types name lookup

Parameters:

msgClass | Class of the message to look up
msgType | Type of the message, depends on the class
defValue | Value to return if lookup fails

Returns: Pointer to message type name

bool transmitMSG (unsigned char msgVersion, unsigned char msgClass, unsigned char msgType, const DataBlock& msg, int streamId = 0) | ### transmitMSG

[const]

Transmit a message to the network transport layer

Parameters:

msgVersion | Version of the protocol
msgClass | Class of the message
msgType | Type of the message, depends on the class
msg | Message data, may be empty
streamId | Identifier of the stream to send the data over

Returns: True if the message was transmitted to network

inline bool transmitMSG (unsigned char msgClass, unsigned char msgType, const DataBlock& msg, int streamId = 0) | ### transmitMSG

[const]

Transmit a message with default version to the network transport layer

Parameters:

msgClass | Class of the message
msgType | Type of the message, depends on the class
msg | Message data, may be empty
streamId | Identifier of the stream to send the data over

Returns: True if the message was transmitted to network

bool restart (bool force) | ### restart

Restart the underlaying transport

Parameters:

force | True to hard restart, false to force restart if transport is down

Returns: True if the transport was notified that it needs to restart

bool getSocketParams (const String& params, NamedList& result) | ### getSocketParams

Get sctp socket parameters.

Parameters:

params | List of parameters to obtain
result | List of parameters to fill

Returns: True if operation was successful, false if an error occurred

bool transportNotify (SIGTransport* newTransport, const SocketAddr& addr) | ### transportNotify

[virtual]

Notification that a new incomming connection has been made

Parameters:

newTransport | The new created transport
addr | The newly created transport socket address

Returns: True if the newTransport will be used.

bool hasTransportThread () | ### hasTransportThread

Check if the transport thread is running

Returns: true if the transport thread is running

void stopTransportThread () | ### stopTransportThread

Stop the transport thread

bool processMSG (unsigned char msgVersion, unsigned char msgClass, unsigned char msgType, const DataBlock& msg, int streamId) | ### processMSG

[protected pure virtual]

Process a complete message

Parameters:

msgVersion | Version of the protocol
msgClass | Class of the message
msgType | Type of the message, depends on the class
msg | Message data, may be empty
streamId | Identifier of the stream the message was received on

Returns: True if the message was handled

Generated by: paulc on bussard on Mon Feb 10 13:15:47 2014, using kdoc 2.0a54.